//DorianTech HTTP Server
//Beautified by jsbeautifier.org
//Uses Content-Type and Content-Length
//Events calling:
//|
//+--request
//|
//+--error
//APIs:
// - https
// - readline
// - os
// - http
// - url
// - fs
// - path
// - hexstrbase64
// - crypto
// - svrjspack
'use strict';
var secure = false;
var logo = ["\x1b[31m",
  "       _______________________________________  ",
  "      /                                       \\ ",
  "     /   ___________________________________   \\",
  "    /   /                                   \\   \\",
  "   /   /                                     \\   \\",
  "  /   /                                       \\   \\",
  " / __/                                         \\   \\",
  "/ /                                             \\   \\ ",
  "|_|                                              \\___\\    ",
  "\x1b[33m",
  "                                                   **      ",
  "                                                  ****     ",
  "                                                   **      ",
  "\x1b[37m",
  "_______                  _                      ________                 __",
  "\\ ___  \\                |_|                    | _    _ |                \\ |",
  "| |  \\ |  _____   ____  __    ____  _    _  _  |/ \\  / \\|  _____   ___   | |______   ",
  "| |  | | /  __ \\  \\  _\\ \\ |  /  __\\/ |  | |/ \\    |  |    /  __ \\ / __\\  |   ___  \\     ",
  "| |__/ | | |__||  | /   | |  | |__|  |  |  _ |    |  |    | /_/_/ | |__  |  /   \\ | ",
  "/______/ \\_____/  /_\\   /_\\  \\_____/_|  |_| \\|    /__\\    \\___\\   \\___/  /_/    /_\\",
  "\x1b[0m"
];
function printLogo() {
  for(i = 0; i < logo.length; i++) {
    console.log(logo[i]);
  }
}
var https = require('https');
var readline = require('readline');
var os = require('os');
var http = require('http');
var url = require('url');
var fs = require('fs');
var path = require('path');
var hexstrbase64 = require('./hexstrbase64/index.js');
var crypto = require('crypto');
var svrmodpack = require('svrmodpack');
var tArgs = process.argv;
var pubip = "";
var pubport = 8000;
var port = 80;
var domian = "";
var spubport = 4433;
var sport = 443;
var mods = [];
var modFiles = fs.readdirSync("./mods");
var modInfos = [];
var deleteFolderRecursive = function(path) {
  if (fs.existsSync(path)) {
    fs.readdirSync(path).forEach(function(file, index){
      var curPath = path + "/" + file;
      if (fs.lstatSync(curPath).isDirectory()) { // recurse
        deleteFolderRecursive(curPath);
      } else { // delete file
        fs.unlinkSync(curPath);
      }
    });
    fs.rmdirSync(path);
  }
};
for(var i=0;i<modFiles.length;i++) {
var modFile = "./mods/" + modFiles[i];
fs.mkdirSync("./temp/" + i.toString());
if(fs.lstatSync(modFile).isFile()) {
	    svrmodpack.unpack(modFile,"./temp/" + i.toString());
        var Mod = require("./temp/" + i.toString());
        var mod = new Mod();
        mods.push(mod);
		modInfos.push(JSON.parse(fs.readFileSync("./temp/" + i.toString() + "/mod.info")));
}
}
if(process.argv0.indexOf("node") > -1) {
  for(var i = 2; i < tArgs.length; i++) {
    if(tArgs[i] == "-h" || tArgs[i] == "--help" || tArgs[i] == "-?" || tArgs[i] == "/h" || tArgs[i] == "/?") {
      console.log("NodeSvr usage:");
      console.log("SVR [-h] [--help] [-?] [/h] [/?] [--secure]");
      console.log("-h -? /h /? --help    -- Dipslays help");
	  console.log("--secure              -- Runs HTTPS Server");
      process.exit(0);
    } else if(tArgs[i] == "--secure") {
		secure = true;
	}
  }
} else {
  for(var i = 0; i < tArgs.length; i++) {
    if(tArgs[i] == "-h" || tArgs[i] == "--help" || tArgs[i] == "-?" || tArgs[i] == "/h" || tArgs[i] == "/?") {
      console.log("NodeSvr usage:");
      console.log("SVR [-h] [--help] [-?] [/h] [/?] [--secure]");
      console.log("-h -? /h /? --help    -- Dipslays help");
	  console.log("--secure              -- Runs HTTPS Server");
      process.exit(0);
    } else if(tArgs[i] == "--secure") {
		secure = true;
	}
  }
}
var api = "https://api.myip.com/";
https.get(api, function(res) {
  res.on('data', function(d) {
    pubip = JSON.parse(d.toString("utf8")).ip;
    if(!Boolean(domian)) {
      var parts = pubip.split(".");
      var p1 = parseInt(parts[0]).toString(16);
      var p2 = parseInt(parts[1]).toString(16);
      var p3 = parseInt(parts[2]).toString(16);
      var p4 = parseInt(parts[3]).toString(16);
      var pp = parseInt(pubport).toString(16);
      domian = p1 + p2 + p3 + p4 + pp + ".nodesvr.dorian-tech.com";
    }
  });
});
var ifaces = os.networkInterfaces();
var ips = [];
var attmts = 5;
var errors = os.constants.errno;
var timestamp = new Date().getTime();
try {
  fs.mkdirSync("log");
} catch(ex) {}

function LOG(s) {
  fs.appendFileSync('log/' + timestamp + ".log", s + "\r\n");
}
var serverconsole = {
  climessage: function(msg) {
    console.log("SERVER CLI MESSAGE: " + msg);
    LOG("SERVER CLI MESSAGE: " + msg);
    return;
  },
  reqmessage: function(msg) {
    console.log("\x1b[34mSERVER REQUEST MESSAGE: " + msg + "\x1b[37m\x1b[0m");
    LOG("SERVER REQUEST MESSAGE: " + msg);
    return;
  },
  resmessage: function(msg) {
    console.log("\x1b[32mSERVER RESPONSE MESSAGE: " + msg + "\x1b[37m\x1b[0m");
    LOG("SERVER RESPONSE MESSAGE: " + msg);
    return;
  },
  errmessage: function(msg) {
    console.log("\x1b[31mSERVER RESPONSE ERROR MESSAGE: " + msg + "\x1b[37m\x1b[0m");
    LOG("SERVER RESPONSE ERROR MESSAGE: " + msg);
    return;
  },
  locerrmessage: function(msg) {
    console.log("\x1b[41mSERVER ERROR MESSAGE: " + msg + "\x1b[40m\x1b[0m");
    LOG("SERVER ERROR MESSAGE: " + msg);
    return;
  },
  locmessage: function(msg) {
    console.log("SERVER MESSAGE: " + msg);
    LOG("SERVER MESSAGE: " + msg);
    return;
  }
};
function sha256(msg) {
	var hash = crypto.createHash("SHA256");
	hash.update(msg);
	return hash.digest('hex');
}
Object.keys(ifaces).forEach(function(ifname) {
  var alias = 0;
  ifaces[ifname].forEach(function(iface) {
    if('IPv4' !== iface.family || iface.internal !== false) {
      // skip over internal (i.e. 127.0.0.1) and non-ipv4 addresses
      return;
    }
    if(alias >= 1) {
      // this single interface has multiple ipv4 addresses
      ips.push(ifname + ':' + alias, iface.address);
    } else {
      // this interface has only one ipv4 adress
      ips.push(ifname, iface.address);
    }
    ++alias;
  });
});
var host = ips[(ips.length) - 1];
var hp = host + ":" + port.toString();
if(!fs.existsSync("config.json")) {
  fs.writeFileSync("config.json", "{\r\n  \"users\": [\r\n    {\r\n\t  \"name\": \"root\",\r\n\t  \"pass\": \"2a096c534bcae8c9ccf2fcb71622ac30cb0c33cb9de3faa3bfa0673362b4607d\"\r\n\t}\r\n  ],\r\n  \"version\": \"1.0\",\r\n  \"defaultpage\": \"index.html\",\r\n  \"page404\": \"404.html\",\r\n  \"welcomeMessage\": \"Welcome to DorianTech Node.JS Server!\"\r\n}");
}
var configJSON = {};
var configJSONf = "";
try {
  configJSONf = fs.readFileSync("config.json"); //Connect to JSON File
} catch(ex) {
  throw new Error("Cannot connect to JSON file!");
}
try {
  configJSON = JSON.parse(configJSONf); //Parse JSON
} catch(ex) {
  throw new Error("JSON Parse error!");
}
var users = configJSON.users; // users
var version = configJSON.version;
var defaultpage = configJSON.defaultpage;
var page404 = configJSON.page404;
var welcomeMessage = configJSON.welcomeMessage;
if(configJSON.port != undefined) {
port = configJSON.port;
}
if(configJSON.pubport != undefined) {
pubport = configJSON.pubport;
}
if(configJSON.domian != undefined) {
domian = configJSON.domian;
}
if(configJSON.sport != undefined) {
sport = configJSON.sport;
}
if(configJSON.spubport != undefined) {
spubport = configJSON.spubport;
}
var key = fs.readFileSync(configJSON.key).toString();
var cert = fs.readFileSync(configJSON.cert).toString();
function substr(s, sc, ec) {
  var out = "";
  if(Boolean(s) === false) {
    throw new Error("Invaild string!");
  }
  if(parseInt(sc) > parseInt(ec)) {
    throw new Error("Invaild numbers!");
  }
  for(var i = 0; i < (ec - sc); i++) {
    out += out.charAt(i + sc);
  }
  return out;
}
//Create server
var server = {};
var http = require("http");
var path = require("path");
var url = require("url");
var server2 = http.createServer(function(req, res) {
	var hostx = req.headers.host;
	var urlp = url.parse("http://" + hostx);
	if(urlp.path.indexOf("//") == 0) {
		urlp = url.parse("http:" + url.path);
	}
	if(urlp.host == "localhost" || urlp.host == "localhost:" + port.toString()) {
		urlp.protocol = "https:";
		urlp.host = urlp.hostname + ":" + sport.toString();
		urlp.port = sport.toString();
	} else if(urlp.host == host || urlp.host == host + ":" + port.toString()) {
		urlp.protocol = "https:";
		urlp.host = urlp.hostname + ":" + sport.toString();
		urlp.port = sport.toString();
	} else if(urlp.host == pubip || urlp.host == pubip + ":" + pubport.toString()) {
		urlp.protocol = "https:";
		urlp.host = urlp.hostname + ":" + spubport.toString();
		urlp.port = spubport.toString();
	} else if(urlp.hostname == domain) {
		urlp.protocol = "https:";
		urlp.host = urlp.hostname;
	}
	urlp.path = null;
	urlp.pathname = null;
	var lloc = url.format(urlp);
	var ext = path.extname(url.parse(req.url,true).pathname);
    try {
          if(ext == "html") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'text/html',
			  'Location': lloc + req.url
            });
          } else if(ext == "css") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'text/css',
			  'Location': lloc + req.url
            });
          } else if(ext == "js") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'application/javascript',
			  'Location': lloc + req.url
            });
          } else if(ext == "json") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'application/json',
			  'Location': lloc + req.url
            });
          } else if(ext == "png" || ext == "tiff" || ext == "jpg" || ext == "bmp") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'image/png',
			  'Location': lloc + req.url
            });
          } else if(ext == "gif") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'image/gif',
			  'Location': lloc + req.url
            });
          } else if(ext == "ico" || ext == "icn" || ext == "icon") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'image/x-icon',
			  'Location': lloc + req.url
            });
          } else if(ext == "svg") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'image/svg+xml',
			  'Location': lloc + req.url
            });
          } else if(ext == "mp4" || ext == "mpeg" || ext == "mpg") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'video/mp4',
			  'Location': lloc + req.url
            });
          } else if(ext == "ogg") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'audio/ogg',
			  'Location': lloc + req.url
            });
          } else if(ext == "mp3" || ext == "mp2") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'audio/mp4',
			  'Location': lloc + req.url
            });
          } else if(ext == "ttf") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'font/ttf',
			  'Location': lloc + req.url
            });
          } else if(ext == "otf") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'font/otf',
			  'Location': lloc + req.url
            });
          } else if(ext == "rtf") {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'text/rtf',
			  'Location': lloc + req.url
            });
          } else {
            res.writeHead(301, "Redirect to HTTPS", {
              'Content-Type': 'text/plain',
			  'Location': lloc + req.url
            });
          }
			  res.end()
        } catch(ex) {
          res.writeHead(500, "Internal Server Error");
          res.write("500 Internal Server Error! Reason: " + ex);
		  res.end();
        }
})
if(secure) {
  server = https.createServer({
	key: key,
    cert: cert	
  });
} else {
  server = http.createServer();
}
server.on('request', function(request, response) {	
  var head = fs.readFileSync("./head.html").toString(); // header
  var foot = fs.readFileSync("./foot.html").toString(); // footer
  var fd = "";
  function responseEnd(d) {
	  if(typeof d === "undefined") d = fd;
	  res.write(head + d + foot);
	  res.end();
  }
  var req = request; // request var is req = request
  var res = response; // response var is res = response
  var reqip = res.socket.remoteAddress;
  var reqport = res.socket.remotePort;
  serverconsole.locmessage("Connecting to port " + pubport + ", sending welcome message...");
  serverconsole.reqmessage("Client " + reqip + ":" + reqport + " wants content in " + hp + req.url);
  serverconsole.resmessage(welcomeMessage);
  var uobject = url.parse(req.url, true);
  var search = "";
  try {
    //search = "?" + url.parse(req.url,false).query;
    search = uobject.search;
    //console.log(url.parse(req.url,false).query);
    //console.log(search);
  } catch(ex) {
    //console.log("Rzucał bląd taki: " + ex);
  }
  var href = uobject.pathname;
  var ext = path.extname(href);
  try {
    if(typeof ext.substr == "function") {
      ext = ext.substr(1, ext.length);
    } else {
      ext = substr(ext, 1, ext.length);
    }
  } catch(ex) {}
  function modExecute(mods,ffinal,ffinals) {
function applyc(a,b) {
	var stro = "mods[%a].callback(req,res,serverconsole,responseEnd,href,ext,uobject,search,defaultpage,users,page404,head,foot,fd,%c)";
	if(a < b-1) {
		return stro.replace(/%a/g,a.toString()).replace(/%c/g,applyc(a+1,b));
	} else if(a < b) {
		return stro.replace(/%a/g,a.toString()).replace(/%c/g,ffinals);
	} else {
		return null;
	}
}
eval(applyc(0,mods.length) + "()");
}
function vres(req,res,serverconsole,responseEnd,href,ext,uobject,search,defaultpage,users,page404,head,foot,fd) {
	return function() {
		
  function responseEnd(d) {
	  if(typeof d === "undefined") d = fd;
	  res.write(head + d + foot);
	  res.end();
  }
  
  if(req.method != "GET" && req.method != "POST") {
    res.writeHead(400, "Invaild Method");
    res.write("400 Bad Request");
    serverconsole.errmessage("Invaild method!");
    res.end();
    return;
  }
  if(req.httpVersion == "1.0" || req.httpVersion == "HTTP 1.0" || req.httpVersion == "HTTP/1.0") {
    res.writeHead(505, "HTTP not supported");
    res.write("505 Bad HTTP Version");
    serverconsole.errmessage("HTTP not supported!");
    res.end();
    return;
  }
  if(href == "/" + defaultpage) {
    res.writeHead(301, "Moved Permanently",{"Location":"/"});
    res.end();
    return;
  }
  if(href == "/config.json") {
    res.writeHead(403, "Forbidden");
	res.write("403 Forbidden");
	serverconsole.errmessage("Access to config file is denied!");
    res.end();
    return;
  }
  if(href == '/') {
    if(fs.existsSync(defaultpage)) {
      fs.readFile(defaultpage, function(err, data) {
        try {
          res.writeHead(200, "Recieved Content", {
            'Content-Length': head.length + data.length + foot.length
          });
		  fd += data;
          serverconsole.resmessage("Client succesully recievied content!");
		  responseEnd();
        } catch(ex) {
          res.writeHead(500, "Internal Server Error");
          res.write("500 Internal Server Error! Reason: " + ex);
		  res.end();
          serverconsole.errmessage("Client fails recieving content!");
        }
      });
    } else {
      if(fs.existsSync(page404)) {
        fs.readFile(page404, function(err, data) {
          try {
            res.writeHead(404, "Not found", {
              'Content-Length': head.length + data.length + foot.length
            });
			fd += data;
			responseEnd();
            serverconsole.errmessage("Client fails recieving content!");
          } catch(ex) {
            res.writeHead(500, "Internal Server Error");
            res.write("500 Internal Server Error! Reason: " + ex);
			res.end();
            serverconsole.errmessage("Client fails recieving content!");
          }
        });
      } else {
        res.writeHead(404, "Not found");
        res.write("404 Not found!");
        serverconsole.errmessage("Client fails recieving content!");
        res.end();
      }
    }
	return;
  } else {
    var uri = href;
    var len = uri.length;
    var pth = uri.substr(1, len - 1);
    if(fs.existsSync(pth)) {
      fs.readFile(pth, function(err, data) {
        try {
          if(ext == "html") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'text/html',
              'Content-Length': head.length + data.length + foot.length
            });
          } else if(ext == "css") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'text/css',
              'Content-Length': data.length
            });
          } else if(ext == "js") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'application/javascript',
              'Content-Length': data.length
            });
          } else if(ext == "json") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'application/json',
              'Content-Length': data.length
            });
          } else if(ext == "png" || ext == "tiff" || ext == "jpg" || ext == "bmp") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'image/png',
              'Content-Length': data.length
            });
          } else if(ext == "gif") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'image/gif',
              'Content-Length': data.length
            });
          } else if(ext == "ico" || ext == "icn" || ext == "icon") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'image/x-icon',
              'Content-Length': data.length
            });
          } else if(ext == "svg") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'image/svg+xml',
              'Content-Length': data.length
            });
          } else if(ext == "mp4" || ext == "mpeg" || ext == "mpg") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'video/mp4',
              'Content-Length': data.length
            });
          } else if(ext == "ogg") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'audio/ogg',
              'Content-Length': data.length
            });
          } else if(ext == "mp3" || ext == "mp2") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'audio/mp4',
              'Content-Length': data.length
            });
          } else if(ext == "ttf") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'font/ttf',
              'Content-Length': data.length
            });
          } else if(ext == "otf") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'font/otf',
              'Content-Length': data.length
            });
          } else if(ext == "rtf") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'text/rtf',
              'Content-Length': data.length
            });
		  } else if(ext == "pdf") {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'application/pdf',
              'Content-Length': data.length
            });
          } else {
            res.writeHead(200, "Recieved Content", {
              'Content-Type': 'text/plain',
              'Content-Length': data.length
            });
          }
		  if(ext == "html") {
              fd += data;
		  } else {
			  res.write(data);
		  }
          serverconsole.resmessage("Client succesully recievied content!");
		  if(ext == "html") {
		    responseEnd();
		  } else {
			  res.end()
		  }
        } catch(ex) {
          res.writeHead(500, "Internal Server Error");
          res.write("500 Internal Server Error! Reason: " + ex);
		  res.end();
          serverconsole.errmessage("Client fails recieving content!");
        }
      });
    } else {
      if(fs.existsSync(page404)) {
        fs.readFile(page404, function(err, data) {
          try {
            res.writeHead(404, "Not found", {
              'Content-Length': head.length + data.length + foot.length
            });
			fd += data;
            serverconsole.errmessage("Client fails recieving content!");
			responseEnd();
          } catch(ex) {
            res.writeHead(500, "Internal Server Error");
            res.write("500 Internal Server Error! Reason: " + ex);
			res.end();
            serverconsole.errmessage("Client fails recieving content!");
          }
        });
      } else {
        res.writeHead(404, "Not found");
        res.write("404 Not found!");
        serverconsole.errmessage("Client fails recieving content!");
        res.end();
      }
    }
	}
	}
}

modExecute(mods,vres,"vres(req,res,serverconsole,responseEnd,href,ext,uobject,search,defaultpage,users,page404,head,foot,fd)");
  serverconsole.resmessage("Goodbye!");
  serverconsole.locmessage("Disconnected");
});
//Listen port to server
server.on("error", function(err) {
  serverconsole.locerrmessage("EXCEPTION: " + err.toString());
  if(err.code == "EADDRINUSE") {
    serverconsole.locerrmessage("Address in use!");
    attmts--;
    serverconsole.locmessage(attmts + " attempts left.");
    server.close();
    if(attmts > 0) {
      start();
    } else {
      process.exit(errors[err.code]);
    }
  } else if(err.code == "EADDRNOTAVAIL") {
    serverconsole.locerrmessage("Address not avialable!");
    attmts--;
    serverconsole.locmessage(attmts + " attempts left.");
    server.close();
    if(attmts > 0) {
      start();
    } else {
      process.exit(errors[err.code]);
    }
  } else if(err.code == "EACCES") {
    serverconsole.locerrmessage("Access denied!");
    attmts--;
    serverconsole.locmessage(attmts + " attempts left.");
    server.close();
    if(attmts > 0) {
      start();
    } else {
      process.exit(errors[err.code]);
    }
  } else {
    process.exit(errors[err.code]);
  }
});
process.on("error", function(err) {
  serverconsole.locerrmessage(err.toString());
  process.exit(os.constants.errno[err.code]);
});

function start(init) {
  if(Boolean(init)) {
    init = true;
  } else {
    init = false;
  }
  if(init) {
    printLogo();
    console.log();
    console.log("Welcome to DorianTech Node.JS Server!");
    console.log();
    serverconsole.locmessage("Server Version: " + version);
    serverconsole.locmessage("Node.JS Version: " + process.version);
    var vnum = 0;
    try {
      vnum = process.config.variables.node_module_version;
    } catch(ex) {}
    var cpus = os.cpus();
    if(cpus.length > 1) {
      serverconsole.locmessage("CPU: " + cpus.length + "x " + cpus[0].model);
    } else {
      serverconsole.locmessage("CPU: " + cpus[0].model);
    }
    if(vnum < 59) {
      throw new Error("Server avialable is for Node.js 9.0.0 and newer, your Node.JS version is not supported by server!");
    }
    //if(os.platform != "win32") {
    //throw new Error("Server avialable is for Windows, your platform is not supported by server!");
    //}
  }
  serverconsole.locmessage("Starting server on localhost:" + port.toString());
  try {
    //if (host == "localhost") {
	if(secure) {
	  server.listen(sport);
      server2.listen(port);
	} else {
	  server.listen(port);
	}
    //} else {
    //server.listen(host + ":" + port.toString())
    //}
    serverconsole.locmessage("Started server at: ");
	if(secure) {
		serverconsole.locmessage(" - https://localhost:" + sport.toString());
	}
    serverconsole.locmessage(" - http://localhost:" + port.toString());
    var exec = require('child_process').exec,
      child;
    if(os.platform == "win32") {
      child = exec('ping 127.0.0.1', function(error, stdout, stderr) {
        if(error !== null) {
          //Pipe broken (no connection)
          serverconsole.locmessage("Failed to start server! Reason: No connection");
          process.exit(32);
        } else {
          var commands = {
            close: function() {
              try {
                server.close();
                serverconsole.climessage("Server closed!");
              } catch(ex) {
                serverconsole.climessage("Cannot close server! Reason: " + ex.message);
              }
            },
            open: function() {
              try {
				if(secure) {
					server.listen(sport);
				} else {
                server.listen(port); // ReOpen Server
				}
                serverconsole.climessage("Server opened!");
              } catch(ex) {
                serverconsole.climessage("Cannot open server! Reason: " + ex.message);
              }
            },
            help: function() {
              serverconsole.climessage("Server commands:\nhelp open close getip stop clear mods");
            },
            getip: function() {
              serverconsole.climessage("IP: " + hp);
            },
			mods: function() {
				serverconsole.climessage("Mods:");
				for(var i=0;i<modInfos.length;i++) {
					serverconsole.climessage((i+1).toString() + ". " + modInfos[i].name + " " + modInfos[i].version)
				}
			},
            stop: function(retcode) {
              if(typeof retcode == "number") {
                process.exit(retcode);
              } else {
                process.exit(0);
              }
            },
            clear: function() {
              console.clear();
            }
          };
		  if(secure) {
			  serverconsole.locmessage(" - https://" + host + ":" + sport);
		  }
          serverconsole.locmessage(" - http://" + host + ":" + port);
		  if(secure) {
              serverconsole.locmessage(" - https://" + pubip + ":" + spubport);
		  }
          serverconsole.locmessage(" - http://" + pubip + ":" + pubport);
		  if(secure) {
			  serverconsole.locmessage(" - https://" + domian);
		  }
          serverconsole.locmessage(" - http://" + domian);
          serverconsole.locmessage("For help type help");
          var rl = readline.createInterface({
            input: process.stdin,
            output: process.stdout,
            prompt: ""
          });
          rl.prompt();
          rl.on('line', function(line) {
            try {
              if(commands[line] !== undefined || commands[line] !== null || line !== "") {
                commands[line]();
              } else if(line === "") {
                //Does Nothing
              } else {
                if(hexstrbase64.hextostr(hexstrbase64.strtohex(line).split("0000").join("")) == "stop") {
                  commands.stop(0);
                } else {
                  serverconsole.climessage("Unregonized command!");
                }
              }
              rl.prompt();
            } catch(ex) {
              if(line === "") {} else if(hexstrbase64.hextostr(hexstrbase64.strtohex(line).split("0000").join("")) == "stop") {
                commands.stop(0);
              } else {
                serverconsole.climessage("Unregonized command!");
              }
            }
          }).on('error', function(err) {
            serverconsole.climessage("Unregonized command!");
          });
        }
      });
    } else {
      child = exec('ping -c 4 0 -w 2', function(error, stdout, stderr) {
        if(error !== null) {
          //Pipe broken (no connection)
          serverconsole.locmessage("Failed to start server! Reason: No connection");
          process.exit(32);
        } else {
          var commands = {
            close: function() {
              try {
                server.close();
                serverconsole.climessage("Server closed!");
              } catch(ex) {
                serverconsole.climessage("Cannot close server! Reason: " + ex);
              }
            },
            open: function() {
              try {
                server.listen(port); // ReOpen Server
                serverconsole.climessage("Server opened!");
              } catch(ex) {
                serverconsole.climessage("Cannot open server! Reason: " + ex);
              }
            },
            help: function() {
              serverconsole.climessage("Server commands:\nhelp open close getip stop clear");
            },
            getip: function() {
              serverconsole.climessage("IP: " + hp);
            },
            stop: function(retcode) {
              if(typeof retcode == "number") {
                process.exit(retcode);
              } else {
                process.exit(0);
              }
            },
            clear: function() {
              console.clear();
            }
          };
          serverconsole.locmessage(" - " + host + ":" + port);
          serverconsole.locmessage(" - " + pubip + ":" + pubport);
          serverconsole.locmessage(" - " + domian);
          serverconsole.locmessage("For help type help");
          var rl = readline.createInterface({
            input: process.stdin,
            output: process.stdout,
            prompt: ""
          });
          rl.prompt();
          rl.on('line', function(line) {
            try {
              if(commands[line] !== undefined || commands[line] !== null || line !== "") {
                commands[line]();
              } else if(line === "") {
                //Does Nothing
              } else {
                if(hexstrbase64.hextostr(hexstrbase64.strtohex(line).split("0000").join("")) == "stop") {
                  commands.stop(0);
                } else {
                  serverconsole.climessage("Unregonized command!");
                }
              }
              rl.prompt();
            } catch(ex) {
              if(line === "") {} else if(hexstrbase64.hextostr(hexstrbase64.strtohex(line).split("0000").join("")) == "stop") {
                commands.stop(0);
              } else {
                serverconsole.climessage("Unregonized command!");
              }
            }
          }).on('error', function(err) {
            serverconsole.climessage("Unregonized command!");
          });
        }
      });
    }
  } catch(ex) {
    serverconsole.locmessage("Failed to start server! Reason: " + ex);
    process.exit(1);
  }
}
function exitHandler(code) {
  //var timestamp = new Date().getTime();
  try {
    //fs.rmdirSync("session");
	var spprt;
	var sprt;
	var pprt;
	var prt;
	var dmn;
	if(configJSON.pubport != undefined) {
		pprt = pubport;
	}
	if(configJSON.port != undefined) {
		prt = port;
	}
	if(configJSON.spubport != undefined) {
		spprt = spubport;
	}
	if(configJSON.sport != undefined) {
		sprt = sport;
	}
	if(configJSON.domian != undefined) {
		dmn = domian;
	}
    var configString = JSON.stringify({
      users: users,
      version: version,
	  key: configJSON.key,
	  cert: configJSON.cert,
	  pubport: pprt,
	  port: prt,
	  domian: dmn,
	  spubport: spprt,
      sport: sprt,	  
      defaultpage: defaultpage,
      page404: page404,
      welcomeMessage: welcomeMessage,
      timestamp: timestamp
    }, null, 2);
    fs.writeFileSync("config.json", configString);
  } catch(ex) {
    throw new Error(ex);
  }
  deleteFolderRecursive("./temp");
  fs.mkdirSync("./temp");
  serverconsole.locmessage("Server closed with exit code: " + code);
}
process.on('exit', exitHandler);
process.on('SIGINT', function(code) {
serverconsole.locmessage("Server terminated using: " + code);
	process.exit();
});
//Call start
start(true);